{ TRichView: how to work with a fixed set of styles.
  Settings: right click RichViewEdit1 in Delphi, choose "Settings" in the
  popup menu. You can see that Mode="Use a predefined set of styles" }

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RVScroll, RichView, RVEdit, RVStyle, Menus;

type
  TForm1 = class(TForm)
    RVStyle1: TRVStyle;
    RichViewEdit1: TRichViewEdit;
    cmbTextStyles: TComboBox;
    btnEditTextStyle: TButton;
    Label1: TLabel;
    cmbParaStyles: TComboBox;
    Label2: TLabel;
    FontDialog1: TFontDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Load1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure cmbTextStylesClick(Sender: TObject);
    procedure cmbParaStylesClick(Sender: TObject);
    procedure RichViewEdit1CurTextStyleChanged(Sender: TObject);
    procedure RichViewEdit1CurParaStyleChanged(Sender: TObject);
    procedure btnEditTextStyleClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
    Updating: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  cmbTextStyles.Items.Assign(RVStyle1.TextStyles);
  cmbParaStyles.Items.Assign(RVStyle1.ParaStyles);
  RichViewEdit1CurTextStyleChanged(nil);
  RichViewEdit1CurParaStyleChanged(nil);
end;

procedure TForm1.cmbTextStylesClick(Sender: TObject);
begin
  if not Updating and (cmbTextStyles.ItemIndex>=0) then begin
    RichViewEdit1.ApplyTextStyle(cmbTextStyles.ItemIndex);
    RichViewEdit1.SetFocus;
  end;
end;

procedure TForm1.cmbParaStylesClick(Sender: TObject);
begin
  if not Updating and (cmbParaStyles.ItemIndex>=0) then begin
    RichViewEdit1.ApplyParaStyle(cmbParaStyles.ItemIndex);
    RichViewEdit1.SetFocus;
  end;
end;

procedure TForm1.RichViewEdit1CurTextStyleChanged(Sender: TObject);
begin
  Updating := True;
  cmbTextStyles.ItemIndex := RichViewEdit1.CurTextStyleNo;
  Updating := False;
end;

procedure TForm1.RichViewEdit1CurParaStyleChanged(Sender: TObject);
begin
  Updating := True;
  cmbParaStyles.ItemIndex := RichViewEdit1.CurParaStyleNo;
  Updating := False;
end;

procedure TForm1.btnEditTextStyleClick(Sender: TObject);
begin
  if cmbTextStyles.ItemIndex<0 then
    exit;
  FontDialog1.Font.Assign(RVStyle1.TextStyles[cmbTextStyles.ItemIndex]);
  if FontDialog1.Execute then begin
    RVStyle1.TextStyles[cmbTextStyles.ItemIndex].Assign(FontDialog1.Font);
    RichViewEdit1.Reformat;
  end;
  RichViewEdit1.SetFocus;
end;
{------------------------------------------------------------------------------}
procedure TForm1.New1Click(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.Format;
  RichViewEdit1CurTextStyleChanged(nil);
  RichViewEdit1CurParaStyleChanged(nil);
end;

procedure TForm1.Load1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then
    exit;
  RichViewEdit1.Clear;
  case OpenDialog1.FilterIndex of
    1: RichViewEdit1.LoadRTF(OpenDialog1.FileName);
    2: RichViewEdit1.LoadText(OpenDialog1.FileName, 0, 0, False);
  end;
  RichViewEdit1.Format;
  RichViewEdit1CurTextStyleChanged(nil);
  RichViewEdit1CurParaStyleChanged(nil);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

end.
